*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE IODECL (LUN, CSYM, CNAM)

************************************************************************
*
* Description: Declare the logical unit number to be reserved.
*              The file is NOT opened!
*
* Called from: anywhere
*
* External references: MEERRO
*
* Argument in/out description
*   LUN    in     logical unit number
*   CSYM   in     symbolic file name
*   CNAM   in     data set name
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"

      INTEGER LUN, I
      CHARACTER CSYM*(*), CNAM*(*), CSTR*80, CC*80

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      CSTR = CSYM
      CALL CLTOU (CSTR)

      IF (CSTR .EQ. 'MINI' .OR. CSTR .EQ. 'DST' .OR.
     +    CSTR .EQ. 'GEOM')  CALL MEERRC 
     +  (456924, 'IOdeclare: name is reserved for groups of' //
     +  'I/O streams')

      IF (LUN .LE. 0 .OR. LUN .GE. 100) THEN
        C78 = 'DECLARE: Logical unit'
        CALL CH78BI (LUN)
        CALL CH78BC ('is not in the range 1 ... 99')
        CALL ME78EC (35)
        GO TO 90
      END IF

      CALL CHHTOC (IQ(HQMEIO_STREAM(1,LUN)), CC) 
      IF (CSTR .EQ. ' ')  GO TO 20

      IF (CSTR .EQ. 'INPUT' .OR. CSTR .EQ. 'OUTPUT')  THEN
        CALL MEERRC (93,
     +  'DECLARE: the names INPUT and OUTPUT refer to all I/O units!')
        GO TO 90
      END IF

      IF (CC .NE. ' ' .AND. CC .NE. CSTR)  THEN
        C78 = 'DECLARE: unit'
        CALL CH78BI (LUN)
        CALL CH78BC ('has already the stream name')
        CALL CH78BC (CC)
        CALL ME78ER
        GO TO 90
      END IF

      DO 10 I = 1, 99
        CALL CHHTOC (IQ(HQMEIO_STREAM(1,I)), CC)
        IF (I .NE. LUN .AND. CSTR .EQ. CC)  THEN
          C78 = 'DECLARE: stream name'
          CALL CH78BC (CSTR)
          CALL CH78BC ('is already declared for unit')
          CALL CH78BI (I)
          CALL ME78ER
          GO TO 90
        END IF
 10   CONTINUE
      CALL CHCTOH (CSTR, IQ(HQMEIO_STREAM(1,LUN)), NMEIO_STREAM)

 20   IF (CNAM .NE. ' ')  THEN
        CALL CHHTOC (IQ(HQMEIO_NAME(1,I)), CC)
        IF (IMEIO_FLAG(LUN) .LE. 0)  THEN
          CALL CHCTOH (CNAM, IQ(HQMEIO_NAME(1,LUN)), NMEIO_NAME)
        ELSE IF (CNAM(1:1) .NE. '(' .AND. CC .NE. CNAM)  THEN
          C78 = 'DECLARE: file name'
          CALL CH78BC (CNAM)
          CALL CH78BC ('ignored')
          CALL ME78WC (17634493)
        END IF
      END IF

 80   IF (IMEIO_FLAG(LUN) .LE. 0 .AND. CNAM .EQ. ' ')  CALL CHCTOH
     +   ('(unspecified)', IQ(HQMEIO_NAME(1,LUN)), NMEIO_NAME)

      IQ(IQMEIO_FLAG(LUN)) = MAX (IMEIO_FLAG(LUN), 0)

 90   RETURN

      END

************************************************************************
* End of IODECL
************************************************************************
