*-- Author :    Hartwig Albrecht   11/07/95

      SUBROUTINE MMBREL (JL, KK1, KK2)

************************************************************************
*
* Description: establish relation.
*              Note: many-to-one relations are not supported. Use
*                    one-to-many instead.
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   JL     in     link to the relation bank
*   K1     in     row number pointing into the 1st table
*   K2     in     row number pointing into the 2nd table
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL(1), IL,IPOS, JSUP, K1, K2, KK1(*), KK2(*), LOCF,
     +   MZBUF(5)
      CHARACTER CNAME*4
      DATA MZBUF /5 * 0/

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      IPOS(I_R) = IMEMO_POS(I_R,IL)
      JSUP(I_R) = JLINK(IMEMO_SUP(I_R,IL))

      K1 = KK1(1)
      K2 = KK2(1)
      IL = LOCF (JL) - LARLN1

C check if JL is a correct Zebra link

      IF (IL .LE. 0 .OR. IL .GT. NARLNK)  GO TO 850

C check that JL refers to a relation

      IF (IMEMO_FLAG(IL) .LE. 0)  GO TO 840

C check validity of K1 and K2

      IF (K1 .LE. 0 .OR. K2 .LE. 0 .OR.
     +  JSUP(1) .EQ. 0 .OR. K1 .GT. N_U(JSUP(1)) .OR.
     +  JSUP(2) .EQ. 0 .OR. K2 .GT. N_U(JSUP(2)))  GO TO 820

      MZBUF(1) = HMEMO_NAME(1,IL)
      MZBUF(5) = IMEMO_FMT(IL)
      GO TO (10,20,810,40), IMEMO_FLAG(IL)

C one to one

 10   IF (I_V(IPOS(1),K1,JSUP(1)) .NE. 0)  GO TO 830
       IQ(L_A(IPOS(1),K1,JSUP(1))) = K2
      IF (I_V(IPOS(2),K2,JSUP(2)) .NE. 0)  GO TO 830
       IQ(L_A(IPOS(2),K2,JSUP(2))) = K1
      GO TO 900

C one to many

 20   IF (JL(1) .EQ. 0)  THEN
        MZBUF(4) = 2 * IMEMO_EXT(IL) + 4
        CALL MZLIFT (IMEMO_DIV(IL), JLINK(IL), 0, 2, MZBUF, 0)
        IQ(JL(1)+1) = 2
        IQ(JL(1)+2) = 1
        IQ(IQMEMO_BOOK(IL)) = IQ(IQMEMO_BOOK(IL)) + 1

      ELSE

        IF (N_F(JL(1)) .EQ. 0)  THEN
          CALL MZPUSH (IMEMO_DIV(IL), JL, 0,
     +       2 * (IMEMO_EXT(IL) + 1), ' ')
          IQ(IQMEMO_EXTN(IL)) = IQ(IQMEMO_EXTN(IL)) + 1
        END IF
        IQ(JL(1)+2) = IQ(JL(1)+2) + 1

      END IF

      IF (I_V(IPOS(2),K2,JSUP(2)) .NE. 0)  GO TO 830
      IQ(L_A(IPOS(2),K2,JSUP(2))) = K1
      IQ(L_L(1,JL(1))) = K2
      IQ(L_L(2,JL(1))) = I_V(IPOS(1),K1,JSUP(1))
      IQ(L_A(IPOS(1),K1,JSUP(1))) = N_U(JL(1))
      GO TO 900

C many to many

 40   IF (JL(1) .EQ. 0)  THEN
        MZBUF(4) = 4 * IMEMO_EXT(IL) + 6
        CALL MZLIFT (IMEMO_DIV(IL), JLINK(IL), 0, 2, MZBUF, 0)
        IQ(JLINK(IL)+1) = 4
        IQ(JLINK(IL)+2) = 1
        IQ(IQMEMO_BOOK(IL)) = IQ(IQMEMO_BOOK(IL)) + 1
        IQ(IQMEMO_EXTN(IL)) = IQ(IQMEMO_EXTN(IL)) + 1

      ELSE

       IF (N_F(JL(1)) .EQ. 0)  THEN
         CALL MZPUSH (IMEMO_DIV(IL), JL, 0,
     +      4 * (IMEMO_EXT(IL) + 1), ' ')
         IQ(IQMEMO_EXTN(IL)) = IQ(IQMEMO_EXTN(IL)) + 1
       END IF
       IQ(JL(1)+2) = IQ(JL(1)+2) + 1

      END IF

      IQ(L_L(1,JL(1))) = K1
      IQ(L_L(2,JL(1))) = I_V(IPOS(2),K2,JSUP(2))
      IQ(L_L(3,JL(1))) = K2
      IQ(L_L(4,JL(1))) = I_V(IPOS(1),K1,JSUP(1))
      IQ(L_A(IPOS(1),K1,JSUP(1))) = N_U(JL(1))
      IQ(L_A(IPOS(2),K2,JSUP(2))) = N_U(JL(1))
      GO TO 900

 810  CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), CNAME)
      CALL MEERRC (764164,
     +   'MMBREL: relation '//CNAME//': many-to-one not supported')
      GO TO 900

 820  CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), CNAME)
      CALL MEERRC (613484,
     +   'MMBREL: relation '//CNAME//': row number out of range')
      GO TO 900

 830  CALL CHHTOC (IQ(HQMEMO_NAME(1,IL)), CNAME)
      CALL MEMESC (3487145, 10, ILARGEST,
     +   'MMBREL: relation '//CNAME//': ...-to-one already established')
      GO TO 900

 840  CALL MEERRC (7153872,
     +   'MMBREL: link JL is not a relation')
      GO TO 900

 850  CALL MEERRC (563472,
     +  'MMBREL: link JL not inside link area')

 900  END

************************************************************************
* End of MMBREL
************************************************************************
