*CMZ :          17/01/97  17.01.42  by  Unknown
*-- Author :
C
      SUBROUTINE F0NPCT(FUNC,IFUNC,XLOW,XHIGH,XFCUM,NLO,NBINS,TFTOT,
     +                  IERR)
C        Array XFCUM is filled from NLO to NLO+NBINS, which makes
C        the number of values NBINS+1, or the number of bins NBINS
      EXTERNAL FUNC
      DIMENSION XFCUM(*)
      PARAMETER (RTEPS=0.005, NZ=10, MAXZ=20, NITMAX=6,PRECIS=1.E-6)
CC      DOUBLE PRECISION TPCTIL, TZ, TCUM, XINCR, DTABS,
CC     +  TINCR, TZMAX, XBEST, DTBEST, DTPAR2
C

      CHARACTER*78 CTEXT 

      INTEGER  LENOCC 
      EXTERNAL LENOCC
 

      IERR = 0
      IF (TFTOT .LE. 0.) GO TO 900
      TPCTIL = TFTOT/NBINS
      TZ = TPCTIL/NZ
      TZMAX = TZ * 2.
      XFCUM(NLO) = XLOW
      XFCUM(NLO+NBINS) = XHIGH
      X = XLOW
      F = FUNC(X)
      IF (F .LT. 0.) GO TO 900
C         Loop over percentile bins
      DO 600 IBIN = NLO, NLO+NBINS-2
      TCUM = 0.
      X1 = X
      F1 = F
      DXMAX = (XHIGH -X) / NZ
      FMIN = TZ/DXMAX
      FMINZ = FMIN
C         Loop over trapezoids within a supposed percentile
      DO 500 IZ= 1, MAXZ
      XINCR = TZ/MAX(F1,FMIN,FMINZ)
  350 X = X1 + XINCR
      F = FUNC(X)
      IF (F .LT. 0.) GO TO 900
      TINCR = (X-X1) * 0.5 * (F+F1)
      IF (TINCR .LT. TZMAX) GO TO 370
      XINCR = XINCR * 0.5
      GO TO 350
  370 CONTINUE
      TCUM = TCUM + TINCR
      IF (TCUM .GE. TPCTIL*0.99) GO TO 520
      FMINZ = TZ*F/ (TPCTIL-TCUM)
      F1 = F
      X1 = X
  500 CONTINUE
      CTEXT='F0NPCT, Problems with trapezoid!'
      CALL MEMESC(834809,0,ILARGEST,CTEXT(1:LENOCC(CTEXT)))
C         END OF TRAPEZOID LOOP
C         Adjust interval using Gaussian integration with
C             Newton corrections since F is the derivative
  520 CONTINUE
      X1 = XFCUM(IBIN)
      XBEST = X
      DTBEST = TPCTIL
      TPART = TPCTIL
C         Allow for maximum NITMAX more iterations on RADAPT
      DO 550 IHOME= 1, NITMAX
  535 XINCR = (TPCTIL-TPART) / MAX(F,FMIN)
      X = XBEST + XINCR
      X2 = X
        IF (IHOME .GT. 1 .AND. X2 .EQ. XBEST) THEN
         CTEXT='F0NPCT, Insuficient precision at!'
         CALL MEMESC(834810,0,ILARGEST,CTEXT(1:LENOCC(CTEXT)))
         GO TO 580
        ENDIF
      REFX = ABS(X)+PRECIS
      CALL RADAPT(FUNC,X1,X2,1,RTEPS,0.,TPART2,UNCERT)
      DTPAR2 = TPART2-TPCTIL
      DTABS = ABS(DTPAR2)
      IF(ABS(XINCR)/REFX .LT. PRECIS) GOTO 545
      IF(DTABS .LT. DTBEST) GOTO 545
      XINCR = XINCR * 0.5
      GOTO 535
  545 DTBEST = DTABS
      XBEST = X
      TPART = TPART2
      F = FUNC(X)
      IF(F .LT. 0.) GOTO 900
      IF(DTABS .LT. RTEPS*TPCTIL) GOTO 580
  550 CONTINUE
         CTEXT='F0NPCT, No convergence!'
         CALL MEMESC(834811,0,ILARGEST,CTEXT(1:LENOCC(CTEXT)))
C
  580 CONTINUE
      XINCR = (TPCTIL-TPART) / MAX(F,FMIN)
      X = XBEST + XINCR
      XFCUM(IBIN+1) = X
      F = FUNC(X)
      IF(F .LT. 0.) GOTO 900
  600 CONTINUE
C         END OF LOOP OVER BINS
      X1 = XFCUM(NLO+NBINS-1)
      X2 = XHIGH
      CALL RADAPT(FUNC,X1,X2,1,RTEPS,0.,TPART ,UNCERT)
      ABERR = ABS(TPART-TPCTIL)/TFTOT
      IF(ABERR .GT. RTEPS)THEN
         CTEXT='F0NPCT, Relative Error!'
         CALL MEMESC(834812,0,ILARGEST,CTEXT(1:LENOCC(CTEXT))) 
      ENDIF 
      RETURN
  900 CONTINUE 
         CTEXT='F0NPCT, Fatal Error!'
         CALL MEMESC(834813,0,ILARGEST,CTEXT(1:LENOCC(CTEXT))) 
         IERR = 1
      RETURN
      END
