//                              -*- Mode: C++ -*-
//: CmdCareStat.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "arte/arte.hh"
#include "care/CmdCareStat.hh"
#include "arte/ArteMessage.hh"

/////////////// The function seen by kuip
#ifdef USEKUIP
extern "C" {
  void carestat_(){
    CmdCareStat statCmd;
    statCmd.readAndExe();
  }
}; // end of extern
#endif
//////////////////////////////////////////////////////////


/*
CLASS
  CmdCareStat
  Base class to deal with the Stat kuip command
};

*/


CmdCareStat::CmdCareStat() : indx(0), status(0) {}

CmdCareStat::~CmdCareStat(){}

void CmdCareStat::defValues(){
  indx = 0;
  status = 0;
}

//--
//   Execute stored command
void CmdCareStat::execute(){
  if( indx>0 && indx<ArtePointer<ECHF>::nrow() ){
    ArtePointer<ECHF> echf(indx);
    echf->stat = (echf->stat & 0xFFFE ) | (status & 1);
  }
}


#ifdef USEKUIP
//--
//   Read a command from external
void CmdCareStat::read(){
  indx = readInt();
  status = readInt();
}
#endif
                          
//--
//   Printout Information for the current lambda info stored
void CmdCareStat::dump(){
  arteMsg<<" Channel :"<<indx
	 <<" New status : "<<status;
  arteMsg.allp();
}




