//                              -*- Mode: C++ -*-
//:caredata.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 29/4/97
// Last Update ........
//
#ifndef CAREDATA_HH_
#define CAREDATA_HH_

// In this file there are all the global static data of the
// ECAL reconstruction

#include "care/ECALtypes.hh"

struct ECAL_Info {
  // default constructor
  ECAL_Info();
  // full constructor
  ECAL_Info(ArtePointer<GESL> ec, int nX, int nY,Coord_t x, Coord_t y,
            Coord_t  xMsz, Coord_t yMsz,  bool in, int dbf, 
	    Energy_t clusTh, Energy_t valleyEn);
  //
  //  data start here
  //
  // Ecal Pointer to GESL table
  ArtePointer<GESL> ecalp;
  // Number of modules in X and Y directions
  int nModX, nModY;
  // Center of ECAL
  Coord_t  x0,y0;
  // Modules size
  Coord_t  xMsize, yMsize;
  // Flag to tell if the CARE routines have been initialized
  bool     init;
  // flag for automatic/manual reading of the database
  int dbflag;
  // Cluster threshold
  Energy_t   clusThr;
  // Two Cluster threshold
  Energy_t   valley;
};


extern ECAL_Info   ECalInfo;

#endif // CAREDATA_HH_
