>NAME DGKUIP
>Menu /HBDIGI
>Guidance  
Commands for digitization.
>Command DGSEL
>Guidance
Select superlayers or groups of superlayers for digitization etc.
.
The syntax is dgsel name1 name2 .... namen, where
.
1. name1 ... namen are superlayer names (4 bytes each) 
.
2. alternatively if name1 = CMP then name 2 ... namem can be
   SVD        all Superlayers with gesl_cmp =1 will be taken (all SVD)  
   OTR                    "                  2      "        (all OTR)
   ITR                    "                  3      "        (all ITR) 
   PTL                    "                  4      "        (all PTL)
   RIC                    "                  5      "        (RICH)          
   TRD                    "                  6      "        (TRD)      
   ECA                    "                  7      "        (ECA) 
   MUD                    "                  8      "        (all MUDi)
   MXD                    "                  9      "        (all MXDi)
.
3. name1 ..  namen can be  
   MAGN      all SVD OTR,ITR,PTL chambers in the magnet will be
             taken, i.e.
             SI08 MS01 MS03 MS05 MS06 MC01 MC02 MC03 MC04 MC05 MC06
             MC08 PTL1 PTL2 PTL3
   PAT       all chambers from pattern recognition region will be taken
             MS10 MS11 MS12 MS13 PC01 PC02 PC03 PC04
   FLT       all detectors for first level trigger will be taken
             PC01 PC04 TC01 TC02 MS10 MS13 MS14 MS15 CALW MUD1 MUD2
             MUD3 MUD4 MXD1 MXD2 MXD3 MXD4
.
4. name can be * - all detectors will be taken
.
5. if a minus sign is preceeding the name (-SI01) the corresponding
detector is exluded from digitization
.
The default is that the digitization will be made for all devices.
However as soon as a dgsel command appears the default value will be
no digitization at all and  each wanted device (group of devices) must
be explicitely given - the whole list for instance can be implemented 
by DGSEL * 

>Action kadgsel%C
>Parameter
SEL 'names of selected superlayers' C

***********************************************************************
>Command DGLEV
>Guidance 
Selects Level of digitisation for detector components
.
The syntax is dgsel name num
.
where name can be   SVD, OTR, ITR, PTL, RIC, TRD, ECA, MUD, MXD
and num is an integer switch inside dgevnt to call different
digitization routines

>Action kadglev%C
>Parameter
LEVNAM 'name of detector component' C 
LEVNUM 'integer swich present in dgevnt' I D=0


********************
>COMMAND NOISE
>Guidance
gives the noise level per wire/strip/cell
. 
The syntax is dgsel name num
.
where name can be   SVD, OTR, ITR, PTL, RIC, TRD, ECA, MUD, MXD
and num is an real, which gives the noise level per cell
>ACTION kadgnoise%C
>PARAMETER
NAME 'name of detector component' C
NOISE  'noise level per wire' R D=0.

***********************************************************************
>Command DGCUT
>Guidance 
Selects region in superlayer/component to be excluded from digitization
.
The syntax is: dgcut -option name xmin xmax ymin ymax
           or: dgcut name xmin xmax ymin ymax option
.
Option:
.
option = SL   for cut on an individual superlayer
         CMP  for cut on an entire component
.
Parameters:
.
name = component name for option CMP
       (exactly one of SVD, OTR, ITR, PTL, RIC, TRD, ECA, MUD, MXD)
       or a single superlayer name for option SL
       (e.g. SI08, MS05, PTL2, PC02, TC01, CALW, MUD1, MXD3,...)
.
xmin = lower horizontal cut position in cm
.
xmax = upper horizontal cut position in cm
.
ymin = lower vertical cut position in cm
.
ymax = upper vertical cut position in cm
.
Action: The region where the conditions xmin<x<xmax AND ymin<y<ymax
        are simultaneously satisfied are EXCLUDED from digitization

>Action KADGCU
>Parameter
SELNAM 'name of selected component or superlayer' C D='TC01'
XMIN   'lower horizontal cut value (cm)' R D=0.
XMAX   'upper horizontal cut value (cm)' R D=10000.
+
YMIN   'lower vertical cut value (cm)' R D=-10000.
YMAX   'upper vertical cut value (cm)' R D=10000.
OPTION 'object to be selected (SL or CMP)' C D='SL'


>Command N2FRAC
>Guidance 
Sets the N2 fraction in RICH radiator vessel (the rest is filled
with C4F10). It is assumed that events have been generated using 100% C4F10
as a radiator, in the digitization step the photons will be detected as
if they were radiated in N2-C4F10 mixture:
photon number and ring radius will be changed accordingly.

>Action N2FRAC
>Parameter
N2FRACTION 'N2 fraction in the vessel' R D=0


>Command PHOFRAC
>Guidance 
Allows simulation of a radiator gas which is less efficient than
freon. The parameter is the fraction of photons that are radiated
compared to full freon tank.
It is assumed that events were generated using 100% C4F10
as a radiator, in the digitization step the photon number and the ring radius 
will be reduced as if the radiaton happened in the low efficiency gas.

>Action PHOFRAC
>Parameter
PHOFRACTION 'Fraction of radiated photons compared to C4F10' R D=1
