
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//         histogram id: 1 - 65535
//
// changes:
// 22 Oct 1999 (AG) removed print-out "here is histogram ..."
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

//
// function code
//
int
DQ_MUON_hit_init()
{
  cout << "DQ_MUON_hit_init()" << endl;

  //=============================
  //  Hits per Event Plots
  //=============================

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa001),"MUON: Hits/event in Mt1",801,-0.5,800.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa002),"MUON: Hits/event in Mt2",801,-0.5,800.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa003),"MUON: Hits/event in Mt3",401,-0.5,400.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xa004),"MUON: Hits/event in Mt4",401,-0.5,400.5);

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xb003),"MUON: Hits/event in Mp3",601,-0.5,600.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xb004),"MUON: Hits/event in Mp4",601,-0.5,600.5);

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc001),"MUON: Hits/event in Mx1",201,-0.5,200.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc002),"MUON: Hits/event in Mx2",201,-0.5,200.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc003),"MUON: Hits/event in Mx3",201,-0.5,200.5);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xc004),"MUON: Hits/event in Mx4",201,-0.5,200.5);

  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd001),"MUON: Hits/event in Muon",100,0,1500);
  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd002),"MUON: Hits/event in Tube",100,0,800);
  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd003),"MUON: Hits/event in Pad",100,0,200);
  // rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0xd004),"MUON: Hits/event in Pixel",100,0,800);
  

  //================================
  //  Occupancy Plots
  //================================

  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1011),"MUON: Occupancy of Mt1.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1012),"MUON: Occupancy of Mt1.2",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1013),"MUON: Occupancy of Mt1.3",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1014),"MUON: Occupancy of Mt1.4",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1015),"MUON: Occupancy of Mt1.5",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1016),"MUON: Occupancy of Mt1.6",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1021),"MUON: Occupancy of Mt2.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1022),"MUON: Occupancy of Mt2.2",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1023),"MUON: Occupancy of Mt2.3",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1024),"MUON: Occupancy of Mt2.4",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1025),"MUON: Occupancy of Mt2.5",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1026),"MUON: Occupancy of Mt2.6",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1031),"MUON: Occupancy of Mt3.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1032),"MUON: Occupancy of Mt3.2",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1041),"MUON: Occupancy of Mt4.1",1088,-444.21,444.21);
  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1042),"MUON: Occupancy of Mt4.2",1088,-444.21,444.21);

  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x2003),"MUON: Occupancy of Mp3",66,-445,445,60,-320,320);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x2004),"MUON: Occupancy of Mp4",66,-445,445,58,-320,320);

  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x3001),"MUON: Occupancy of Mx1",46,-39.6,39.6,30,-29.7,29.7);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x3002),"MUON: Occupancy of Mx2",46,-39.6,39.6,30,-29.7,29.7);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x3003),"MUON: Occupancy of Mx3",90,-39.6,39.6,16,-29.7,29.7);
  rhp_hbook2(DQ_ID(COMP_MUON,LVL_HIT,0x3004),"MUON: Occupancy of Mx4",96,-45.12,45.12,18,-32.9,32.9);

  //=======================
  // Occupancy vs BX plots
  //=======================
  //  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1),"MUON: Mt1 hits in BX",222,-0.5,221.5);
  //  rhp_hbook1(DQ_ID(COMP_MUON,LVL_HIT,0x1),"MUON: Mt1 hits in BX",221,-0.5,220.5);

  return 0; // return error code (0 = okay)
}
