
// ******************************************************************
//
// M. Braeuer/ D. Samtleben
//
// Declaration of Histograms and Initialization
// Histogram ID:     32 bits
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
// 23 Feb 2000 (MB) Macro bug fixed
// 16 May 2000 (GS) Vertexing histograms added
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte include
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"

#include "cats/hbook.h"

//
// function code
//
int
DQ_SVD_rec_init()
{
#define VDS_MAXPLANES 128
#define VDS_plane_l  -0.5  // lower bound for plane
#define VDS_plane_h 127.5  // upper bound for plane

  cout << "DQ_VDS_rec_init()" << endl;
  
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,200),"VDS tracks/event",
	     200, -0.5, 199.5 );

  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,201),"VDS Hits/plane tracks",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,202),"VDS occupancy tracks",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h, 128,0.,1280.);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,203),"VDS residuals",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h,100,-149,149);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,204),"VDS total residual",
	     100,-149,149);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,205),"VDS Angular coverage tracks",
	     200,-249.9,249.9, 200,-249.9,249.9);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,206),"VDS hits/track",
	     25,-0.5,24.5);

// Vertexing Histograms
//======================================================================
//      now GEDE-independent booking
//======================================================================

  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,300),"VDS vertex/event",20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,301),"VDS vertex/ev wire 1", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,302),"VDS vertex/ev wire 2", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,303),"VDS vertex/ev wire 3", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,304),"VDS vertex/ev wire 4", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,305),"VDS vertex/ev wire 5", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,306),"VDS vertex/ev wire 6", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,307),"VDS vertex/ev wire 7", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,308),"VDS vertex/ev wire 8", 20, -0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_SVD, LVL_REC,309),"VDS tracks/vertex",    50, -0.5,49.5);
  rhp_hbook2(DQ_ID(COMP_SVD, LVL_REC,310),"VDS vertex/event vs n.wires",
	     20, -0.5,19.5,9,-0.5,8.5);


  return 0; // return error code (0 = okay)
}
