#include "arte/arte.hh"
#include "gean/gclink.h"
#include "gean/zgbeam.hh"

extern "C" {
   void crrotm_(int &,float &,float &,float &,float &,float &,float &);
}

int   zgbeam::time_swit;
float zgbeam::sigb_time;
float zgbeam::meanb_time;
  
float zgbeam::x[3];
float zgbeam::rotm[9];
int   zgbeam::hdir;


void zgbeam::Set_time(int swit, float sig, float mean) {
   time_swit = swit; sigb_time = sig;  meanb_time = mean;
}  

int zgbeam::Get_time(float &sig, float &mean) {
   sig = sigb_time;   mean = meanb_time; return time_swit;
}

void zgbeam::ini_beamshift(int inp){
   int rotnr = 0; 
   float cxdeg = 0.03946, sxdeg =89.96054, dxdeg = 90.03946;   
   float f0 = 0.,  f90=90.,   f180= 180.;

   if(hdir == -1) hdir=inp;

   if(hdir == 0) {
      rotm[0]  = 1.;         rotm[1] = 0.;        rotm[2] = 0.;
      rotm[3]  = 0.;         rotm[4] = 1.;        rotm[5] = 0.;
      rotm[6]  = 0.;         rotm[7] = 0.;        rotm[8] = 1.;
      x[0] = 0.;             x[1] = 0.;           x[2] = 0.; 
     return;
   }
   else if(hdir < 0) {
      crrotm_(rotnr,sxdeg,f0,f90,f90,cxdeg,f180);
      x[0] = .3155,   x[1] = 0.,   x[2] = 0.; 
   }
   else if(hdir > 0) {
      crrotm_(rotnr,dxdeg,f0,f90,f90,cxdeg,f0);
      x[0] =-.3155,   x[1] = 0.,   x[2] = 0.;
   }
   int jrot = *(gcbank_.lq + gclink_.jrotm -1 - rotnr);
   memcpy(rotm, gcbank_.iq + jrot, 36);
}

void zgbeam::rotate(float pnew[],const float pold[]) {
   pnew[0] = rotm[0]*pold[0] + rotm[3]*pold[1] + rotm[6]*pold[2] ; 
   pnew[1] = rotm[1]*pold[0] + rotm[4]*pold[1] + rotm[7]*pold[2] ;
   pnew[2] = rotm[2]*pold[0] + rotm[5]*pold[1] + rotm[8]*pold[2] ;
}


void zgbeam::translate(float pnew[],const float pold[]) {
   pnew[0] = x[0] + pold[0];
   pnew[1] = x[1] + pold[1];
   pnew[2] = x[2] + pold[2];
}
  
float * zgbeam::Get_x() { 
   return x; 
}  

void zgbeam::Set_hdir(int i) {
   hdir =i;
}

int  zgbeam::Get_hdir() {
   return hdir;
}
