*CMZ :          01/04/96  20.21.16  by  Fedor Ratnikov
*-- Author :    Alexander Snizhko   14/01/95
************************************************************************
*
* MUROT
* written by Alexander Snizhko, 14/01/95 17.52.53
*
* This routines action:
* Transform the HB coordinates for Muon chambers into standard
* absolute form
*----------------------------------------------------------------------*
* X_LEFT    in      Xmin in absolute  of the chamber center:0.5*(X_L+X_R)
* X_RIGHT   in      Width of the chamber: X_R-X_L
* Y_LOW     in           ---- // ----
* Y_HIGH    in           ---- // ----
* SINX      in      SIN of rotation angle
* COSX      in      COS    --- // ---
* OUT(4)    out     X_L,X_R,Y_L,Y_H in standard way
*                   X_L - left X of chamber in Y=0...
*
************************************************************************
c
      SUBROUTINE MUROT(X_LEFT,X_RIGHT,Y_LOW,Y_HIGH,SINX,COSX,OUT)

c
      IMPLICIT NONE
      REAL X_LEFT,X_RIGHT,Y_LOW,Y_HIGH,SINX,COSX,OUT
      DIMENSION OUT(4)
      REAL x1,x2,x3,x4,y1,y2,y3,y4
c
      REAL xabs,yabs,xlocal,ylocal
      xabs(xlocal,ylocal) = xlocal*COSX+ylocal*SINX  ! x-transformation
      yabs(xlocal,ylocal) = -xlocal*SINX+ylocal*COSX ! y-transformation
c
      x1 = xabs(X_LEFT,Y_LOW)
      y1 = yabs(X_LEFT,Y_LOW)
      x2 = xabs(X_LEFT,Y_HIGH)
      y2 = yabs(X_LEFT,Y_HIGH)
      x3 = xabs(X_RIGHT,Y_LOW)
      y3 = yabs(X_RIGHT,Y_LOW)
      x4 = xabs(X_RIGHT,Y_HIGH)
      y4 = yabs(X_RIGHT,Y_HIGH)
      OUT(1)=x1-y1*(x2-x1)/(y2-y1)  ! left X with Y=0
      OUT(2)=x3-y3*(x4-x3)/(y4-y3)  ! right X with Y=0
C
      OUT(3)=MIN(y1,y2,y3,y4)       ! bottom in Y
      OUT(4)=MAX(y1,y2,y3,y4)       ! top in Y
c
      RETURN
c
      END
