*
*  B.Fominykh  17.04.2000
*  a program of MuonID package
*  defines the overlap of two TMP7 branchs
*  input:  IB1 - branch 1 number
*          IB2 - branch 2 number
*          IPR - print control, print if IPR=1
*  output: NB1 - number of hits in the branch 1
*          NB2 - number of hits in the branch 2
*          NBC - number of common hits 
* 
      SUBROUTINE MURBRBR(IB1,IB2,IPR,NB1,NB2,NBC)
C-    ===========================================
      IMPLICIT NONE
#include "murec/MUCBTAB.fi"
      INTEGER IB1,IB2,IPR,NB1,NB2,NBC
      INTEGER LB1(50),LB2(50),LBC(50)
      INTEGER IC,ICL,JCL,IH,IH1,IH2,JH,JBR,I1,I2,I,J
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      NB1=0
       NBC=0
        NB2=0
      DO I=1,50
        LB1(I)=0
        LBC(I)=0
        LB2(I)=0
      ENDDO
* list of branch 1 hits
      JBR=JTMP7+IQ(JTMP7+1)*(IB1-1)+2
      IF(IQ(JBR+8).GT.0) THEN
        DO 10 IC=1,IQ(JBR+8)
          ICL=IQ(JBR+LCMUTR+IC)
          JCL=JTMP8+IQ(JTMP8+1)*(ICL-1)+2
          IH1=IQ(JCL+15)
          IH2=IQ(JCL+16)
          DO IH=IH1,IH2
            JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
            IF(IQ(JH+13).EQ.ICL) THEN
              NB1=NB1+1
              LB1(NB1)=IQ(JH+1)
            ENDIF
          ENDDO
  10    CONTINUE
      ENDIF
* list of branch 2 hits
      JBR=JTMP7+IQ(JTMP7+1)*(IB2-1)+2
      IF(IQ(JBR+8).GT.0) THEN
        DO 20 IC=1,IQ(JBR+8)
          ICL=IQ(JBR+LCMUTR+IC)
          JCL=JTMP8+IQ(JTMP8+1)*(ICL-1)+2
          IH1=IQ(JCL+15)
          IH2=IQ(JCL+16)
          DO IH=IH1,IH2
            JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
            IF(IQ(JH+13).EQ.ICL) THEN
              NB2=NB2+1
              LB2(NB2)=IQ(JH+1)
            ENDIF
          ENDDO
  20    CONTINUE
      ENDIF

* overlap between hits
      IF(NB1.LE.0.OR.NB2.LE.0) GOTO 200
      DO I1=1,NB1
        DO I2=1,NB2
          IF(LB1(I1).EQ.LB2(I2)) THEN
            NBC=NBC+1
            LBC(NBC)=LB1(I1)
          ENDIF
        ENDDO
      ENDDO
*
      IF(IPR.GT.0) THEN
***        WRITE(LLOGF,1001) IB1,IB2,NB1,NB2,NBC
        PRINT 1001,IB1,IB2,NB1,NB2,NBC
 1001   FORMAT(1X,'overlap: br1,br2',2I4,
     +  ' Nhit(br1,br2) ',2I3,' Nhit(common)',I3)

      IF(IPR.EQ.2) THEN
***        IF(NB1.GT.0) WRITE(LLOGF,1002) (LB1(J),J=1,NB1)
        IF(NB1.GT.0) PRINT 1002,(LB1(J),J=1,NB1)
 1002   FORMAT(2X,'BR1:',20I4,2(/,5X,20I4))
***        IF(NB2.GT.0) WRITE(LLOGF,1002) (LB2(J),J=1,NB2)
        IF(NB2.GT.0) PRINT 1002,(LB2(J),J=1,NB2)
 1003   FORMAT(2X,'BR2:',20I4,2(/,5X,20I4))
***        IF(NBC.GT.0) WRITE(LLOGF,1004) (LBC(J),J=1,NBC)
        IF(NBC.GT.0) PRINT 1004,(LBC(J),J=1,NBC)
 1004   FORMAT(2X,'COM:',20I4,2(/,5X,20I4))
      ENDIF
      ENDIF
*
 200  CONTINUE
      RETURN
      END







