

      subroutine dicube(wc,border_col,volume_col,border_wid)

*     **** draw cube-like, 8-cornered, 6-faced object

      implicit none
#include "pris/zgraf.fi"

*     **** llist=1 triggers listing of wire coordinates
      real xxx(8), yyy(8),border_col,volume_col,border_wid
      real wc(3,*), wccm(3,6), depth(6)
      integer ii, seq(6), nseq
      integer iface, corner, dim
      integer face(4,6)
      data face /
     +     1, 2, 3, 4,          ! front face
     +     1, 4, 8, 5,          ! right face
     +     2, 3, 7, 6,          ! left face
     +     1, 2, 6, 5,          ! top face
     +     3, 4, 8, 7,          ! bottom face
     +     5, 6, 7, 8 /         ! back face

      do ii=1,8                 ! projection
         call dipro(wc(1,ii),xxx(ii),yyy(ii))
      enddo

      if (iviewzg.eq.0) then
         seq(1) = 1             ! draw front only
         nseq   = 1
      elseif (iviewzg.eq.1) then
         seq(1) = 4             ! draw top side only
         nseq   = 1
      elseif (iviewzg.eq.2) then
         seq(1) = 2             ! draw left side only
         nseq   = 1
      elseif (iviewzg.ge.3.or.iviewzg.le.10) then
         do iface=1,6
            do dim=1,3
               wccm(dim,iface) = 0.
            enddo
            do corner=1,4
               do dim=1,3
                  wccm(dim,iface) = wccm(dim,iface)
     +                 + wc(dim,face(corner,iface))
               enddo
            enddo
            do dim=1,3
               wccm(dim,iface) = wccm(dim,iface) / 6. ! luxury
            enddo
            call didepth(wccm(1,iface),depth(iface))
            depth(iface) = depth(iface) * idirzg ! view direction
         enddo
         nseq = 6
         call sortzv(depth,seq,6,+1,1,0) ! sort decr depth
      else
         print *,' () dicube: unsupported view', iviewzg
      endif
      call isplci(int(border_col)) ! set graphics style
      call igsg(1)
      call isln(1)
      call igset('FACI',volume_col)
      call igset('FAIS',1.)

      do ii=1,nseq
         iface = seq(ii)        ! faces in sorted order
*     *            print *,' dicube: draw face ', iface
         do corner=1,4
            call dipro(
     +           wc(1,face(corner,iface)),xxx(corner),yyy(corner))
         enddo

         xxx(5) = xxx(1)        ! close the parallelogram
         yyy(5) = yyy(1)

         call igset('PLCI',volume_col)
         call igset('FACI',volume_col)
         call igset('FAIS',1.)
         call igset('BORD',0.)
         call ifa(5,xxx,yyy)    ! draw volume

         call igset('PLCI',border_col) ! draw border
         call igset('FAIS',0.)
         call igset('LWID',border_wid)
         call ipl(5,xxx,yyy)
      enddo

      end
