*CMZ :  4.04/00 16/12/95  17.30.31  by  Rainer Mankel
*-- Author :    Rainer Mankel   16/12/95


      subroutine didepth(dc,zzz)

*     **** projects 3dim detector frame coordinates onto
*     **** view direction (complements xxx and yyy delivered by dipro)
      implicit none
#include "pris/zgraf.fi"

      real dc(3), dcs(3), zzz
      real cp, sp, ct, st, radeg
      integer ii
      data radeg /57.29578/

      if (iviewzg.eq.0) then
*      **** xy view
       zzz = dc(3)
      elseif (iviewzg.eq.1) then
*      **** xz view
       zzz = dc(2)
      elseif (iviewzg.eq.2) then
*      **** yz view
       zzz = dc(1)
      elseif (iviewzg.ge.3.and.iviewzg.le.6) then
       if (iviewzg.eq.3) then
*       **** spatial view
        ct = cos(thetzg / radeg)
        st = sin(thetzg / radeg)
        cp = cos(phizg / radeg)
        sp = sin(phizg / radeg)
       elseif (iviewzg.eq.4) then
*       **** isometric view
        ct = sqrt(2./3.)
        st = sqrt(1./3.)
        cp = sqrt(0.5)
        sp = cp
       elseif (iviewzg.eq.5) then
*       **** dimetric view
        ct = sqrt(0.8)
        st = sqrt(0.2)
        cp = sqrt(0.75)
        sp = 0.5

       elseif (iviewzg.eq.6) then
*       **** trimetric view
        ct = sqrt(5./6.)
        st = sqrt(1./6.)
        cp = sqrt(0.7)
        sp = sqrt(0.3)
       endif

*      **** scale factors
       do 10 ii=1,3
 10    dcs(ii) = dc(ii) * fscalzg(ii)

       zzz =   sp * ct * dcs(1) + st * dcs(2) + cp * ct * dcs(3)

      elseif (iviewzg.eq.7) then
*      **** x-stereo view (u)
       zzz = .087156 * dc(1) + .996195 * dc(2)
      elseif (iviewzg.eq.8) then
*      **** x-stereo view (v)
       zzz = -.087156 * dc(1) + .996195 * dc(2)
      elseif (iviewzg.eq.9) then
*      **** cone-correction view
       zzz = dc(2)
      elseif (iviewzg.eq.10) then
*      **** cone-correction view with hyperbolic blowup
       zzz = dc(2)
       elseif (iviewzg.eq.11) then
*      **** track-angle view
       zzz = dc(3)
      else
       print *,' () didepth: invalid view, iviewzg=',iviewzg
      endif

      end


