*-- Author :    Rainer Mankel   28/07/93

      subroutine difram()

      implicit none
#include "pris/zgraf.fi"
#include "arte/ArteFlag.fi"
*     **** define frame
*     **** called by kuip
      character*40 chopt
      real x1, x2, y1, y2, xlow, xhigh, ylow, yhigh, xmid, ymid, xwid,
     +     ywid, fact
      integer maxStack, nStack, ii, jj
      parameter (maxStack=5) 
      real frameStack(4,maxStack)
      logical init      
      integer nch, istat, nt

      data init /.false./
      save frameStack, nStack

      if (.not.init) then
         do ii=1,maxStack       ! clear frame stack
            do jj=1,4
               frameStack(jj,ii) = 0.
            enddo
         enddo
         init = .true.
      endif

      if (prisinit.eq.0) call dicinit() ! automatic initialization

*     **** frame bounds
      call kugetr(x1)
      call kugetr(x2)
      call kugetr(y1)
      call kugetr(y2)
*     **** options
      call kugetc(chopt,nch)
      call kugetr(fact)

      if (x1.ne.0..or.x2.ne.0.) then
       istat = 1
       go to 100
      endif

c=============================================== Move Up / Down / Left / righT
      if (index(chopt,'U').gt.0
     @.or.index(chopt,'D').gt.0
     @.or.index(chopt,'L').gt.0
     @.or.index(chopt,'T').gt.0) then

         do ii=maxStack,2,-1    ! push stack
            do jj=1,4
               frameStack(jj,ii) = frameStack(jj,ii-1)
            enddo
         enddo
         frameStack(1,1) = x1zg
         frameStack(2,1) = x2zg
         frameStack(3,1) = y1zg
         frameStack(4,1) = y2zg

         xmid = 0.5 * (x1zg + x2zg)
         ymid = 0.5 * (y1zg + y2zg)
         xwid = abs(x2zg - x1zg)
         ywid = abs(y2zg - y1zg)

         if (fact.eq.0.) fact = 1.
         if (index(chopt,'U').gt.0) then
            y1zg = y1zg + fact * ywid
            y2zg = y2zg + fact * ywid
         else if (index(chopt,'D').gt.0) then
            y1zg = y1zg - fact * ywid
            y2zg = y2zg - fact * ywid
         else if (index(chopt,'L').gt.0) then
            x1zg = x1zg - fact * xwid
            x2zg = x2zg - fact * xwid
         else if (index(chopt,'T').gt.0) then
            x1zg = x1zg + fact * xwid
            x2zg = x2zg + fact * xwid
         end if
         call difrset()
         ntzg = 1
         if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
         go to 999
      end if

c=======================================================================

      if (index(chopt,'R').gt.0) then
*      **** option R: just reset to standard window

       do ii=maxStack,2,-1          ! push stack
          do jj=1,4
             frameStack(jj,ii) = frameStack(jj,ii-1)
          enddo
       enddo
       frameStack(1,1) = x1zg
       frameStack(2,1) = x2zg
       frameStack(3,1) = y1zg
       frameStack(4,1) = y2zg

       iframzg = 1
*      **** normalize boundaries depending on viewing angles
       call difrno()
       if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
       go to 999

      endif

      if (index(chopt,'I').gt.0) then ! zoom in

         do ii=maxStack,2,-1    ! push stack
            do jj=1,4
               frameStack(jj,ii) = frameStack(jj,ii-1)
            enddo
         enddo
         frameStack(1,1) = x1zg
         frameStack(2,1) = x2zg
         frameStack(3,1) = y1zg
         frameStack(4,1) = y2zg

         xmid = 0.5 * (x1zg + x2zg)
         ymid = 0.5 * (y1zg + y2zg)
         xwid = 0.5 * abs(x2zg - x1zg)
         ywid = 0.5 * abs(y2zg - y1zg)
         x1zg = xmid - 0.5 * xwid
         x2zg = xmid + 0.5 * xwid
         y1zg = ymid - 0.5 * ywid
         y2zg = ymid + 0.5 * ywid
         call difrset()
         ntzg = 1
         if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
         go to 999
      endif

      if (index(chopt,'O').gt.0) then ! zoom out

         do ii=maxStack,2,-1    ! push stack
            do jj=1,4
               frameStack(jj,ii) = frameStack(jj,ii-1)
            enddo
         enddo
         frameStack(1,1) = x1zg
         frameStack(2,1) = x2zg
         frameStack(3,1) = y1zg
         frameStack(4,1) = y2zg

         xmid = 0.5 * (x1zg + x2zg)
         ymid = 0.5 * (y1zg + y2zg)
         xwid = 0.5 * abs(x2zg - x1zg)
         ywid = 0.5 * abs(y2zg - y1zg)
         x1zg = xmid - 2.0 * xwid
         x2zg = xmid + 2.0 * xwid
         y1zg = ymid - 2.0 * ywid
         y2zg = ymid + 2.0 * ywid
         call difrset()
         ntzg = 1
         if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
         go to 999
      endif

      if (index(chopt,'B').gt.0) then ! pop back previous frame
         if (frameStack(1,1).eq.0..and.frameStack(2,1).eq.0.
     +        .and.frameStack(3,1).eq.0.
     +        .and.frameStack(4,1).eq.0.) then
            print *,' difram: no previous frame'
            go to 999
         endif
         x1zg = frameStack(1,1)
         x2zg = frameStack(2,1)
         y1zg = frameStack(3,1)
         y2zg = frameStack(4,1)
         do ii=1,maxStack-1    ! pop stack
            do jj=1,4
               frameStack(jj,ii) = frameStack(jj,ii+1)
            enddo
         enddo
         call difrset()
         ntzg = 1
         if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
         go to 999
      endif


*     **** input new window boundaries via rubberband
      call igsa(1)
      print *,' use rubberband to select boundaries '
      call igsg(1)
      call iuwk(0,1)
      nt = nt_framzg
      call igloc2(1,nt,x1,y1,x2,y2,istat,'P')
      call igsa(1)
**      print *,' difram: locator returns nt,x1,y1,x2,y2,istat=',
**     +     nt,x1,y1,x2,y2,istat

      if (nt.le.0) then
       print *,' () difram: outside of borders ... please try again '
       print *,' nt=', nt
       go to 999
      endif

*     **** interpretation of borders
 100  continue
      xlow  = amin1(x1,x2)
      xhigh = amax1(x1,x2)
      ylow  = amin1(y1,y2)
      yhigh = amax1(y1,y2)

      if (istat.ne.1.or.xlow.ge.xhigh.or.ylow.ge.yhigh) then
       print *,' () difram: terminates due to error'
       go to 999
      endif

      do ii=maxStack,2,-1       ! push stack
         do jj=1,4
            frameStack(jj,ii) = frameStack(jj,ii-1)
         enddo
      enddo
      frameStack(1,1) = x1zg
      frameStack(2,1) = x2zg
      frameStack(3,1) = y1zg
      frameStack(4,1) = y2zg

      x1zg = xlow
      x2zg = xhigh
      y1zg = ylow
      y2zg = yhigh
      call difrset()
      ntzg = 1

      if (index(chopt,'N').eq.0) call didraw() !  redraw the picture

 999  end
