// 
//  Author:  Alexander Spiridonov              Created:  20.05.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextrini.C

#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "gean/ZGESL.h"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"


// Prototypes

extern "C" void rgextini_() {

// initialization

  if(rgmc_())
    {
//                 MC data

      zfparext_.dmax_ty_vdmu = 0.07;
      zfparext_.dmax_y_vdmu = 10. ;
      zfparext_.min_p_vdmu = 5.;
      zfparext_.dmax1_x_vdmu = 5.;
      zfparext_.dmax1_y_vdmu = 1000.;

      zfparext_.dmax_ty_vdmuri = 0.004;
      zfparext_.dmax_tx_vdmuri = 0.004;
      zfparext_.dmax_teta_mu = 1.0;

      zfparext_.z_match_mu = 1630.;      

      zfparext_.refrac_rich  = 1.00137;

      zfparext_.dmax_ty_muri = 0.006;

      switch(zfparext_.id_cut_seed) {

      case 0:
//                                            soft cuts
//	cout << "rgextini : soft " << endl;
	zfparext_.xmin_clust = 25.;        
	zfparext_.ymin_clust = 25;
	zfparext_.emin_clust = 1.;
	zfparext_.ptmin_clust = 0.;
	zfparext_.erxmax_clust = 0.5;
	zfparext_.erymax_clust = 0.5;
	zfparext_.dmax_ty_clri = 0.003;
	zfparext_.dmax_tx_clri = 0.3;
	break;

      case 1:
//                                            rough cuts
//      cout << "rgextini : rough " << endl;
	zfparext_.xmin_clust = 25.;        
	zfparext_.ymin_clust = 25;
	zfparext_.emin_clust = 2.;
	zfparext_.ptmin_clust = 0.;
	zfparext_.erxmax_clust = 0.3;
	zfparext_.erymax_clust = 0.3;
	zfparext_.dmax_ty_clri = 0.003;
	zfparext_.dmax_tx_clri = 0.3;
	break;

      case 2:
//                                            IT & rough cuts
//	cout << "rgextini : ITcuts " << endl;
	zfparext_.xmin_clust = 10.;        
	zfparext_.ymin_clust = 10;
	zfparext_.emin_clust = 2.;
	zfparext_.ptmin_clust = 0.;
	zfparext_.erxmax_clust = 0.3;
	zfparext_.erymax_clust = 0.3;
	zfparext_.dmax_ty_clri = 0.003;
	zfparext_.dmax_tx_clri = 0.3;
	break;

      }

//        cout << "rgextini : cut x,y " << zfparext_.erxmax_clust
//             << " " << zfparext_.erymax_clust << endl;

      for( ArteTableIterator <GESL> slayer;
	   slayer.valid(); slayer.next() )
	{
	  if(slayer->cmp == LGESL_MAG)
	    {
	      zfparext_.zmin_magn =slayer->z1;
	      zfparext_.zmax_magn =slayer->z2;
//	      cout << " MAGNET z1 " << zfparext_.zmin_magn
//		   << " z2 " << zfparext_.zmax_magn << endl;
	    }
	}
    }
  else
    {
      zfparext_.zmin_magn = 190.;
      zfparext_.zmax_magn = 685.;
//	      cout << " real MAGNET z1 " << zfparext_.zmin_magn
//		   << " z2 " << zfparext_.zmax_magn << endl;
    }
}
