// 
//  Author:  Alexander Spiridonov              Created:  18.05.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextreco.C
//
//       reconstruct OT-segments from external seeds
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfextse.hh"
#include "rang/zfparext.hh"

// Prototypes

extern "C" void rgextreco_() {

// initialization

  static int FirstCall = 1;

  if(FirstCall)
    {
      tfhbinit_();
      rgextini_();
      FirstCall = 0;
    }                   
      
  switch(zfparext_.id_seed_ext){
    
  case 0:
    rgextios_(0);   // input seeds from user defined RSEG
    break;

  case 1:
    rgextcrse_();      // define eCAL-RICH seeds
    break;

  case 2:
    rgextvmrse_();  // define VDS-MUON-RICH seeds   
    break;

  case 3:
    rgextmrse_();  // define MUON-RICH seeds
    break;

  default:
    rgextios_(0);   // input seeds from user defined RSEG
    break;
}

  if(zfparext_.id_save_seed ==1 && zfparext_.id_seed_ext !=0)
    {
      rgextios_(1);  // save seeds in RSEG
    }

//  rgextios_(0);   // build seeds from user defined RSEG

  tfextre_();       // segments reconstruction

//  rgextmass_(0, 1, 0.10566);  // histogramm of invariant mass
//  rgextmass_(0, 0, 0.005);  
                   
//  rgextmoms_();      // update of momentum of reconstructed segments
                   
//  rgextmass_(1, 1, 0.10566);   // histogramm of invariant mass
//  rgextmass_(1, 0, 0.005);    
                   
//  rgextspr_();       // print seeds
                   
//  tfextstat_();      // stat. analysis of segments reconstuction
                     
}
