// 
//  Author:  Rainer Mankel                     Created:  10-Oct-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "arte/arte.hh"
#include "rang/setCmp.hh"

// function rgsetcmp_
// Fortran interface to rangerSetCmp(...).
// Determines the CMP bits (for rseg->cmp) for a given RSEG row number. 
// Optionally, the new patterned is ORed with a given bitmap.
// Result is returned as integer. The rseg itself is not changed.
// Callable from Fortran

extern "C" {
  int rgsetcmp_(const int& rseg,const int& cmp) {
    ArtePointer<RSEG> rs(rseg);
    return rangerSetCmp( rs,cmp );
  }
}
