// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgxproqpt
// Fortran getter function for the qpt estimate of a given horizontal 
// projection track candidate.
// This estimate has normally been produced from the visible deflection
// of the track by the magnet.

#include "rang/Domain.hh"
#include "rang/DomWin.hh"
#include "rang/DomObj.hh"
#include "rang/XPro.hh"
#include "rang/XWin.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  double rgxproqpt_() {
    return rangerDO->xpro()->qpt();
  }
}
