*-- Author :    Rainer Mankel   22/05/96

      subroutine tfpropy(direction)
*     **** vertical track-follow all alive seeds in /zf/
*     **** (between begin_ft and nca_ft)
      implicit none
#include "arte/Arte.fi"
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax), n_target, tumchit
      integer ift, izf, ipl, icycle, method, ncan, ii,
     +        zone, iplnext, imust, izfnew, nhl, nhlmx, ihl, iii,
     +        domlay,dw,dlnext,direction
      real u, y, tfxint, dz, y_pred, dy_window

#include "rang/zdomain.fi"

      parameter (nhlmx=100)
      integer hl(nhlmx), nca_now, to_be_grown
      logical continued

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"

**      print *,' this is tfpropy...'
**      call rgxprodmp()

*     **** loop over growth cycles
      do 10 icycle=1,99

*      **** loop over present number of track candidates
       nca_now = nca_ft
       to_be_grown = 0
       do 20 ift=begin_ft,nca_now
        if (.not.alive_ft(ift)) go to 20
        if (mature_ft(ift))     go to 20
        to_be_grown = to_be_grown + 1

        if (diag_level.ge.4) then
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
         print *,' << track candidate ', ift, '                    <<'
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
        endif

*       **** loop over planes in zone
        izf = last_ft(ift)
        ipl = plane_zf(izf)
        domlay = domlay_zf(izf)
        zone = fault_zf(izf) + 1
        ncan = 0
        continued = .false.
        method = 3  ! y tracking
        if (diag_level.ge.4) then
         print *,' tfpropy: call tfdzone2 for domlay=', domlay,
     +           '  zone=', zone,' direction ', direction
        endif

        call tfdzone2(domlay,method,zone,direction,nmax,target_vec,
     +       n_target)

**      x = tfxint(fgede_zmin(ipl))
**      if (igede_cmp(ipl).eq.1.or.igede_cmp(ipl).eq.3) then
**         u = x * fgede_rot(1,ipl) - xx_zf(2,izf) * fgede_rot(2,ipl)
**      elseif (igede_cmp(ipl).eq.2) then
**         u =            x * fgede_cos(ipl)
**   +          - xx_zf(2,izf) * fgede_sin(ipl)
**      else
**         print *,' () tfpropy: invalid cmp=', igede_cmp(ipl)
**      endif

        if (diag_level.ge.5) then
         print *,' tfpropy: domlay,method,zone,n_target,target_vec=',
     +                     domlay,method,zone,n_target,
     +                     (target_vec(iii),iii=1,n_target)
        endif
        do 30 ii=1,n_target
           dlnext = target_vec(ii)

*          **** check if navigable
           if (.not.lx_dlx(win_dl(dlnext))) go to 30

*          **** check if window is intersected
           dz = fgede_zmin(gede_dp(layplane1_dl(dlnext))) - z_zf(izf)
           y_pred = xx_zf(2,izf) + xx_zf(4,izf) * dz
           dy_window = 20.0
           dw = win_dl(dlnext)
           if (y_pred.lt.(ymin_dw(dw)-dy_window).or.
     +          y_pred.gt.(ymax_dw(dw)+dy_window)) go to 30

*          **** can/must plane found
           ncan = ncan + 1

*          **** loop over hits
           call tfdhlcr(izf,dlnext,nhlmx,hl,nhl)

           do 40 ihl=1,nhl
              if (diag_level.ge.5) then
                 print *,' tfpropy: hitlist ihl=',ihl,' hit=',
     +                hl(nhl),' imc=', tumchit(hl(nhl))
              endif
              iplnext = ihitb_gede(hl(nhl))
**              print *,' tfpropy: call tffily'
              call tffily(hl(ihl),dlnext,iplnext,ift,izf,izfnew)
**              print *,' tfpropy: tffily done'
              if (izfnew.gt.0) continued = .true.
 40        continue


 30     continue

*       **** allow fault on old candidate
        if (fault_zf(izf).lt.maxflt_paty_zfpar) then
           fault_zf(izf) = fault_zf(izf) + 1
           nfault_ft(ift) = nfault_ft(ift) + 1
           if (l_diag) then
              if (diag_level.ge.5) then
                 print *,' tfpropy: new fault ',fault_zf(izf),
     +                ' on ift=',ift
              endif
           endif
        else
*          **** kill or freeze old candidate
           if (l_diag) then
              if (diag_level.ge.5) then
                 print *,' tfpropy: terminate ',
     +                'maxflt=',maxflt_paty_zfpar,' ift=',ift
              endif
           endif
           if (nhit_zf(izf).lt.nhitmin_y_zfpar) then
              alive_ft(ift) = .false.
              if (l_diag) then
                 if (diag_level.ge.5) then
                    print *,' tfpropy: kill for nhit_zf=',nhit_zf(izf)
                 endif
              endif
           else
              mature_ft(ift) = .true.
              stat_ft(ift) = 2
           endif
        endif
**        if (diag_level.ge.5) call tfl()

 20    continue
       call tfweey()
       if (l_diag) then
          if (diag_level.ge.4) then
             print *,' **********************************************'
             print *,' *                                            *'
             print *,' *                                            *'
             print *,' *           E  N  D     O  F                 *'
             print *,' *                                            *'
             print *,' *           G  R  O  W  T  H                 *'
             print *,' *                                            *'
             print *,' *            C  Y  C  L  E                   *'
             print *,' *                                            *'
             print *,' *                                            *'
             print *,' **********************************************'
             call tfl()
          endif
          call tfwait()
       endif

       if (to_be_grown.le.0) go to 11

 10   continue
      print *,' () tfpropy: loop ends ii=99'

 11   if (diag_level.ge.4) then
       call tfl()
       print *,' **** end growing of seed **** '
      endif

      if (l_diag) call tfwait()

      end
