#ifndef _riter_planarmirror_h_
#define _riter_planarmirror_h_
#include <riter/RITER.hh>
#include <rich/rich.h>

/// class with information about planar mirrors   
class RITERPlanarmirror {
protected:  
  /// positions of upper nonsegmented planar mirror
  RITERVec rp_mu;

  /// positions of lower nonsegmented planar mirror
  RITERVec rp_md;    

  /// normals of upper nonsegmented planar mirror
  RITERVec ezp_mu;

  /// normals of lower nonsegmented planar mirrors
  RITERVec ezp_md;
  
  /// bases of upper and lower nonsegmented planar mirrors 
  RITERVec pl_vn[2];
  ///  
  RITERVec pl_vx[2];
  ///
  RITERVec pl_vy[2];
  /// planar mirrors (up,dn)
  RITERVec pl_r0[2];  

  /// pl_vx.mag2() 
  float pl_dx[2];
  ///  pl_vy.mag2()
  float pl_dy[2];  

  /// corrections for the planar mirrors x-direction
  float dx_plm[35];
  /// corrections for the planar mirrors y-direction
  float dy_plm[35];

public:

  /// returns vn base vector of the planar mirror id;
  RITERVec   Plvn(int id){ return pl_vn[id]; };
  /// returns vx base vector of the planar mirror id;
  RITERVec   Plvx(int id){ return pl_vx[id]; };
  /// returns vy base vector of the planar mirror id;
  RITERVec   Plvy(int id){ return pl_vy[id]; };
  /// returns position  of the planar mirror id;
  RITERVec   Plr0(int id){ return pl_r0[id]; };
  /// returns which planar mirror was hit
  int Which_PLM( RITERVec  &r0, RITERVec  &dir,int which,float &path );
  /// Print content of the class
  int PrintPlanarmirror();
  /// constructor
  RITERPlanarmirror();
  /// destructor
  ~RITERPlanarmirror(){};

};

#endif

