// *****************************************************************************
//
// source:    L3_DTLT.C
//
// type:      source code
//
// created:   06 Dec 1999
//
// author:    Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// symbol:    
//
// changes:
//
// *****************************************************************************
#include "L3_DTLT.hh"

L3_DTLT::L3_DTLT() {
}

L3_DTLT::L3_DTLT(const L3_DTLT& a) { *this = a; }

L3_DTLT& L3_DTLT::operator = (const L3_DTLT& a) {
  impactP = a.impactP;
  vertexP = a.vertexP;
  return *this;
}

void L3_DTLT::fill(const L3_Event& Ev, const L3_State& St ) {
}

void L3_DTLT::reset(){
  impactP.clear();
  vertexP.clear();
}

void L3_DTLT::add(L3_TrackData& d){ impactP.push_back(d); }
void L3_DTLT::add(L3_VertexData& d){ vertexP.push_back(d); }

vector<L3_VertexData> L3_DTLT::vertices() const { return vertexP; }
vector<L3_TrackData> L3_DTLT::impactParam() const { return impactP; }




