////ArteSelect.C////////////////////////////////////////
//
//  Author:   Vitali Khachatryan     
//
//  Date:   22.02.99
// 
// 29.10.99 Modified by V. Khachatryan (gmail.F routine added to the
// array of functions)
// 10.11.99 cask0b.F added by S. Nowak
//  
//  Description: Selective Initialization of ARTE Modules
//  
//
//
/////////////////////////////////////////////////////////
#include <iostream.h>
extern "C" 
{
#include "usSelect.hh"
#include "arte/ArteSelect.hh"
#include "arte/mecCount.h"


  //The following piece of code is written to avoid -u linker options  
  //in the Makefile.setup (Christoph Borgmeiers idea).
 
   void turemc_(); void qnext_(); void higclu_(); void irqlc_ (); 
   void dirinit_(); void gdcxyz_(); void gpart_ (); void gpmate_(); 
   void gptmed_(); void grkuta_(); void gufld_ (); void guinti_(); 
   void gukine_(); void guout_ (); void gustep_(); void guswim_();
   void gutrak_(); void gutrev_(); void hginit_(); void lugive_(); 
   void gthion_(); void gmail_(); void cask0b_(); 

  typedef void (*func)(); 
  func unresolved[] = 
{
turemc_, qnext_,  

#ifdef MONTE_CARLO
   gmail_, higclu_, cask0b_, 
#endif

irqlc_,

#ifdef DRAW
   dirinit_,  
#endif

#ifdef MONTE_CARLO
   gdcxyz_, gpart_ , gpmate_, gptmed_, grkuta_, 
   gufld_ , guinti_, gukine_, guout_ , gustep_, 
   guswim_, gutrak_, gutrev_, hginit_, lugive_, 
#endif

irqlc_, 

#ifdef MONTE_CARLO
   gthion_ 
#endif
};
//
//



// Monte Carlo function calls to be switched ON/OFF
   void aldata_();  void lundkuip_();  void hgkuip_();
   void gintri_();  void ginit_();  void hgcons_();
   void alinit_();  void phevnt_();  void alevnt_();
   void hgevnt_();  void dgevnt_();  void hginit_();
//
// Prism function calls to be switched ON/OFF
   void dikuip_();  void metakuip_();  void igend_();
   void gdinit_();  void dirinit_();
//

  void arteselect_(int* block, int* initcall);

#ifndef MONTE_CARLO
  void rgsdim_() {cout<<"This is dummy copy of routine rgsdim.F";}
#endif
}//extern "C"

  void MCinitCall(int initcall);
  void DRAWinitCall(int initcall);


//This function selects ARTE module to be initialized*/

void arteselect_(int* block, int* initcall)
{
#ifndef MONTE_CARLO
  static int sti_mc=0;
   int errPtr1;
#endif 
#ifndef DRAW
   static int sti_draw=0;
   int errPtr2;
#endif 

   if(*block==I_MONTE_CARLO)
   {
#ifdef MONTE_CARLO
    MCinitCall(*initcall);
#else
    if(!sti_mc)
    mecWarningCount(&errPtr1,"!!!MONTE CARLO MODULE IS SWITCHED OFF IN THE <usSelect.hh> FILE!!!");
    sti_mc++;
#endif
    }

if(*block==I_DRAW)
  {
#ifdef DRAW
    DRAWinitCall(*initcall);
#else
    if(!sti_draw)
    mecWarningCount(&errPtr2,"!!!DRAWING MODULE IS SWITCHED OFF IN THE <usSelect.hh> FILE!!!");
    sti_draw++;
#endif
   }
}
//
 
//This function calls routines from Monte Carlo module of ARTE
void MCinitCall(int i_init)
 {
#ifdef MONTE_CARLO
  switch (i_init) 
   {
    case I_ALDATA: aldata_(); break; 
    case I_LUNDKUIP: lundkuip_(); break;
    case I_HGKUIP: hgkuip_(); break;
    case I_GINTRI: gintri_(); break;
    case I_GINIT:  ginit_(); break;
    case I_HGCONS: hgcons_(); break;
    case I_ALINIT: alinit_(); break;
    case I_PHEVNT: phevnt_(); break;
    case I_ALEVNT: alevnt_(); break;
    case I_HGEVNT: hgevnt_(); break;
    case I_DGEVNT: dgevnt_(); break;
    case I_HGINIT: hginit_(); break;
    }
#endif
 }
//


//This function calls routines from Drawing module of ARTE
void DRAWinitCall(int i_init) 
 {
#ifdef DRAW
  switch (i_init) 
     {
      case I_DIKUIP: dikuip_(); break;
      case I_METAKUIP: metakuip_(); break;
      case I_IGEND: igend_(); break;
      case I_DIRINIT: dirinit_(); break;
      case I_GDINIT: gdinit_(); break;
      }
#endif
 }
//
