*CMZ :          30/09/96  14.10.18  by  T. Oest
*-- Author :    T. Oest   25/09/96

      SUBROUTINE V0YZ(TRK1, TRK2, ZINT, SZINT, IRET)

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"

      INTEGER           TRK1, TRK2, IRET
      DOUBLE PRECISION  ZINT, SZINT


      LOGICAL           SCATT
      INTEGER           TR(2)
      INTEGER           IERR1, IERR2, ITERA, I, J
      DOUBLE PRECISION  X(2), Y(2), Z(2), TX(2), TY(2), RHO(2), PINV(2)
      DOUBLE PRECISION  ARHO(2), QTRK(2), LAMBDA(2), PHI(2)
      DOUBLE PRECISION  XC(2), ZC(2), DELTA(2),DY
      DOUBLE PRECISION  A, B, F, FPRIME, S1, S2, DDTY
      DOUBLE PRECISION  PTRK1(5), PTRK2(5), VTRK1(5,5), VTRK2(5,5)
      REAL*4            R(3), FIELD(3), BF(2)

      INTEGER           MAXIT
      DOUBLE PRECISION  EC

#include "arte/Arte.ff"
#include "auto/EV.ff"


      DATA   MAXIT  /20/
      DATA   EC     / 2.99792458D-4 /, SCATT /.FALSE./
************************************************************************
      IRET   = 0
      ITERA  = 0
C-----------------------------------------------------------------------
C  fill in track parameter
C-----------------------------------------------------------------------
c      print*,'********************************'
      TR(1)  = TRK1
      TR(2)  = TRK2

      DO I=1,2
       J          = TR(I)
       PINV(I)    = DBLE( FRTRA_PF(J) ) * EC
       TX(I)      = DBLE( FRTRA_TXF(J) )
       TY(I)      = DBLE( FRTRA_TYF(J) )
       X(I)       = DBLE( FRTRA_XF(J) )
       Y(I)       = DBLE( FRTRA_YF(J) )
       Z(I)       = DBLE( FRTRA_ZF(J) )
       QTRK(I)    = SIGN(1.D0,RHO(I))
       PHI(I)     = 0.0
c       PRINT*,' TRACK   ',I
c       PRINT*,' XYZ     ',X(I),Y(I),Z(I)
c       PRINT*,' T,RHO,Q ',TX(I),TY(I),RHO(I)
c       PRINT*,' Q,DELTA ',QTRK(I)
      ENDDO
C-----------------------------------------------------------------------
C  LOOP
C-----------------------------------------------------------------------
 10   CONTINUE
C
C-----------------------------------------------------------------------
C  RHO
C-----------------------------------------------------------------------
      DO I=1,2
       R(1) = SNGL(X(I))
       R(2) = SNGL(Y(I))
       R(3) = SNGL(Z(I))
       CALL UTFELD(R, FIELD)
       IF (ABS(FIELD(2)) .GE. 1.E-6) THEN
        RHO(I) = 1. / (PINV(I) * FIELD(2))
       ELSE
        RHO(I) = 1. / (PINV(I) * SIGN(1.E-6, FIELD(2)))
       ENDIF
       BF(I)   = FIELD(2)
       ARHO(I) = ABS(RHO(I))
       DELTA(I)   = -QTRK(I) * SIGN(1., FIELD(2))* ATAN(TX(I))
       LAMBDA(I)  = TY(I) / SQRT(1.+TX(I)**2)
      ENDDO

C-----------------------------------------------------------------------
C  no field??
C-----------------------------------------------------------------------
      IF (ABS(BF(1)).LE.1.E-2 .OR. ABS(BF(2)).LE.1.E-2) THEN
       IF (TY(1).EQ.TY(2)) THEN
        IRET = -1
        GOTO 9000
       ENDIF

       ZINT = (Y(2)-Y(1)+Z(1)*TY(1)-Z(2)*TY(2))/(TY(1)-TY(2))

      ELSE
C-----------------------------------------------------------------------
C  center of circles
C-----------------------------------------------------------------------
      DO I=1,2
       XC(I) = X(I) - RHO(I)         / SQRT(1.+TX(I)**2)
       ZC(I) = Z(I) + RHO(I) * TX(I) / SQRT(1.+TX(I)**2)
      ENDDO
C-----------------------------------------------------------------------
C  increment in phi
C-----------------------------------------------------------------------
      A = ARHO(1)*LAMBDA(1)/(ARHO(2)*LAMBDA(2))
      B = (Y(1)-Y(2))/(ARHO(2)*LAMBDA(2))

      F = ZC(2) - ZC(1) + ARHO(2) * SIN(A*PHI(1)+B+DELTA(2))
     +                  - ARHO(1) * SIN(PHI(1)+DELTA(1))

      FPRIME = A * ARHO(2) * COS(A*PHI(1) + B + DELTA(2))
     +       - ARHO(1) * COS(PHI(1)+DELTA(1))

      PHI(1) = PHI(1) - F/FPRIME
      ZINT   = ZC(1) + ARHO(1) * SIN(PHI(1)+DELTA(1))

c      print*,' z iteration ',zint

      ENDIF
C-----------------------------------------------------------------------
C  NEW TRACK PARAMETER
C-----------------------------------------------------------------------
      CALL V0SWIM (SCATT, TR(1), ZINT, PTRK1, VTRK1, IERR1)
      CALL V0SWIM (SCATT, TR(2), ZINT, PTRK2, VTRK2, IERR2)
      IF (IERR1.NE.0 .OR. IERR2.NE.0) THEN
       IRET = -1
       GOTO 9000
      ENDIF

       DDTY   = PTRK2(4)- PTRK1(4)
       SZINT = (VTRK1(2,2)+VTRK2(2,2))/DDTY**2
     + + 2.*ZINT*(VTRK1(2,4)*PTRK2(4)-VTRK2(2,4)*PTRK1(4))/DDTY**3
     + + ZINT**2*(VTRK1(4,4)*PTRK2(4)**2+VTRK2(4,4)*PTRK1(4)**2)/DDTY**4
       SZINT = SQRT(SZINT)
       SZINT = SQRT(VTRK1(2,2)+VTRK2(2,2))/ABS(DDTY)
c      SZINT  = SQRT(VTRK1(2,2)/PTRK1(4)**2 +
c     +              VTRK2(2,2)/PTRK2(4)**2)

C-----------------------------------------------------------------------
C  NEXT STEP ?
C-----------------------------------------------------------------------
       X(1)       = PTRK1(1)
       Y(1)       = PTRK1(2)
       TX(1)      = PTRK1(3)
       TY(1)      = PTRK1(4)
       X(2)       = PTRK2(1)
       Y(2)       = PTRK2(2)
       TX(2)      = PTRK2(3)
       TY(2)      = PTRK2(4)
       Z(1)       = ZINT
       Z(2)       = ZINT

      DY = ABS((PTRK1(2)-PTRK2(2))/SQRT(VTRK1(2,2)+VTRK2(2,2)))
      IF (ITERA.LT.MAXIT) THEN
       IF (ITERA.EQ.0 .OR. DY.GE.0.5) THEN
        ITERA = ITERA + 1
        GOTO 10
       ENDIF
      ELSE
       IRET = -3
       GOTO 9000
      ENDIF

C-----------------------------------------------------------------------
C  end
C-----------------------------------------------------------------------
 9000 END

************************************************************************
* End of V0YZ
************************************************************************
