*CMZ :          21/07/97  18.49.06  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       function:   VTDVT(iv,it)                         R*8
c
c       input:    iv       vertex index                  Int
c                 it       track index                   Int
c
c       output:   distance vertex -- track (chi**2, NDF=2)
c
c-------------------------------------------------------------
c
      double precision 
     1  function VTDVT(iv,it)

      implicit none
#include "vt/vtdat.fi"

      integer iv,it

      double precision 
     1  cov(3,3), Vmat(4,4)
      double precision 
     1  x(3)

      integer i,j,ifail,iv1,l


      do  i = 1, 3
        x(i) = xvs(i,iv)
        do  j = 1, 3
          cov(i,j) = CS(i,j,iv)
        enddo
      enddo

      VTDVT = 1.d30

      call VTINIT(x,cov,iv1,ifail)
      if ( ifail.lt.0 ) goto 999
      call VTADD(iv1,it,ifail)
      if ( ifail.lt.0 ) goto 100

c--->  invert the covariance matrix of the track
      if (invflg(it).ne.4) then
        do  j = 1, 4
          do  l = 1, 4
            Vmat(j,l) = V(j,l,it)
          enddo
        enddo
        call DSINV(4,Vmat,4,ifail)
        if (ifail.eq.-1) goto 100
        invflg(it) = 4
        do  j = 1, 4
          do  l = 1, 4
            G(j,l,it) = Vmat(j,l)
          enddo
        enddo
      endif

      call VTFILT(iv1,0,ifail)
      if ( ifail.lt.0 ) goto 100

      VTDVT = chi2(iv1,1)

  100 continue

      call VTDEL(iv1,ifail)

  999 continue

      return
      end
