*--  Author   :     D.Samtleben    17.01.98
*--  changed  :     A.Spiridonov   14.05.98

************************************************************************
      SUBROUTINE VTRINI(IRTRA)
************************************************************************
*
* Description:  fill track buffer of vertex package of T.Lohse
*
* Called from:  vtrec
*
* External references:  
*
* Argument in/out description:
*    IRTRA  is a number of row from table RTRA 
*           to put in track buffer
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"
#include "vt/vtdat.fi"
#include "vt/vt_rtra.fi"

      INTEGER IRTRA, INDEX(5,5), I,J,K,L
      REAL*4  X, Y, Z, TX, TY, X0, Y0
      REAL*4  NEWOLD(5,5), VOLD(5,5)

#include "arte/Arte.ff"
#include "auto/EV.ff"

      DATA INDEX / 6,  9,  4,  5, 13,
     +             9,  10, 7,  8, 14,
     +             4,  7,  1,  2, 11,
     +             5,  8,  2,  3, 12,
     +            13, 14, 11, 12, 15/
   
      data newold /25*0./                                ! by AS 
 
************************************************************************

        TRMULT = TRMULT + 1

        vt_rtra(trmult) = IRTRA                   ! store rtra track number

        X  = FRTRA_XF(IRTRA)
        Y  = FRTRA_YF(IRTRA)
        Z  = FRTRA_ZF(IRTRA)
        TX = FRTRA_TXF(IRTRA)
        TY = FRTRA_TYF(IRTRA)
        X0 = X - TX * Z                           
        Y0 = Y - TY * Z                          

        P(1,TRMULT)   = DBLE(TX)
        P(2,TRMULT)   = DBLE(TY)
        P(3,TRMULT)   = DBLE(X0)
        P(4,TRMULT)   = DBLE(Y0)
        IF (FRTRA_PF(IRTRA).NE.0.0) THEN  
         P(5,TRMULT)   = DBLE(1./ABS(FRTRA_PF(IRTRA)))
        ELSE
         P(5,TRMULT)   = 10.0 * 0.                     ! by AS
        ENDIF
        XMASS(TRMULT) = 0.0

        NEWOLD(1,1) = 1.
        NEWOLD(2,2) = 1.
        NEWOLD(3,1) = -Z
        NEWOLD(3,3) = 1.
        NEWOLD(4,2) = -Z
        NEWOLD(4,4) = 1.
        NEWOLD(5,5) = 1.

        DO I=1,5
        DO J=I,5
         VOLD(I,J)  = FRTRA_CVF(INDEX(I,J),IRTRA)
         IF (I.EQ.5) VOLD(I,J) = 
     +    -SIGN(1.,FRTRA_PF(IRTRA)) * VOLD(I,J) * SNGL(P(5,TRMULT))**2
         IF (J.EQ.5) VOLD(I,J) = 
     +    -SIGN(1.,FRTRA_PF(IRTRA)) * VOLD(I,J) * SNGL(P(5,TRMULT))**2
        VOLD(J,I) = VOLD(I,J)                   
        ENDDO
        ENDDO
*
        DO I=1,5
        DO J=I,5
        V(I,J,TRMULT) = 0.0D0
        DO K=1,5
        DO L=1,5
         V(I,J,TRMULT) = V(I,J,TRMULT) +
     +        DBLE(NEWOLD(I,K) * VOLD(K,L) * NEWOLD(J,L))
        ENDDO
        ENDDO
        V(J,I,TRMULT) = V(I,J,TRMULT)                         
        ENDDO
        ENDDO


************************************************************************
* End of VTRINI
************************************************************************
 900  END
